SystemOrganization addCategory: #'Seaside-Email'!
SystemOrganization addCategory: #'Seaside-Email-Configuration'!

WAObject subclass: #WAEmailBody
	instanceVariableNames: 'contentString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Email'!

!WAEmailBody methodsFor: 'accessing' stamp: 'PaulDeBruicker 10/25/2013 11:14'!
<= anEmailBody
	^ self sortOrder <= anEmailBody sortOrder! !

!WAEmailBody methodsFor: 'comparing' stamp: 'PaulDeBruicker 10/25/2013 11:09'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ self contentType = anObject contentType! !

!WAEmailBody methodsFor: 'accessing' stamp: 'PaulDeBruicker 11/6/2013 15:19'!
contentString
	^ contentString! !

!WAEmailBody methodsFor: 'accessing' stamp: 'PaulDeBruicker 11/6/2013 15:19'!
contentString: aString
	contentString := aString! !

!WAEmailBody methodsFor: 'accessing' stamp: 'PaulDeBruicker 10/25/2013 11:15'!
contentType
	^ self subclassResponsibility! !

!WAEmailBody methodsFor: 'accessing' stamp: 'PaulDeBruicker 11/6/2013 15:19'!
greaseString
	^ self contentString! !

!WAEmailBody methodsFor: 'comparing' stamp: 'PaulDeBruicker 10/25/2013 11:09'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ self contentType hash
! !

!WAEmailBody methodsFor: 'testing' stamp: 'PaulDeBruicker 10/25/2013 11:57'!
isHtml
	^ false! !

!WAEmailBody methodsFor: 'testing' stamp: 'PaulDeBruicker 10/25/2013 10:48'!
isPlainText
	^ false! !

!WAEmailBody methodsFor: 'accessing' stamp: 'PaulDeBruicker 10/25/2013 11:15'!
sortOrder
	^ self subclassResponsibility! !

!WAEmailBody methodsFor: 'accessing' stamp: 'PaulDeBruicker 11/6/2013 15:46'!
writeOn: aStream
	aStream
		nextPutAll: 'Content-Type: ';
		nextPutAll: self contentType greaseString ;
		nextPut: Character cr;
		nextPut: Character cr;
		nextPutAll: self contentString;
		nextPut: Character cr! !

WAEmailBody subclass: #WAHtmlEmailBody
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Email'!

!WAHtmlEmailBody class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/25/2013 11:16'!
renderingBlock: anHtmlRenderingBlock
	^ self new renderBlock: anHtmlRenderingBlock! !

!WAHtmlEmailBody methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/7/2013 10:41'!
contentType
	^ WAMimeType textHtml! !

!WAHtmlEmailBody methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/25/2013 11:57'!
isHtml
	^ true! !

!WAHtmlEmailBody methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/6/2013 15:19'!
renderBlock: anHtmlRenderingBlock
	self
		contentString:
			(WAHtmlCanvas builder
				fullDocument: true;
				render: anHtmlRenderingBlock)! !

!WAHtmlEmailBody methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/25/2013 11:15'!
sortOrder
	^ 2! !

WAEmailBody subclass: #WAStringEmailBody
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Email'!

!WAStringEmailBody class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 11/6/2013 15:19'!
contentString: aString
	^ self new
		contentString: (self convertCrLfToCrIn: aString);
		yourself! !

!WAStringEmailBody class methodsFor: 'private' stamp: 'lr 7/25/2011 19:50'!
convertCrLfToCrIn: aString
	^ aString
		copyReplaceAll: (String with: Character cr with: Character lf)
		with: (String with: Character cr)! !

!WAStringEmailBody class methodsFor: 'private' stamp: 'lr 7/25/2011 19:50'!
splitIntoLines: aString
	^ Array streamContents: [ :stream |
		| cr start |
		cr := Character cr.
		start := 1.
		1 to: aString size do: [ :index |
			(aString at: index) = cr ifTrue: [
				stream nextPut: (aString copyFrom: start to: index - 1).
				start := index + 1 ] ].
			start <= (aString size + 1) ifTrue: [ 
				stream nextPut: (aString copyFrom: start to: aString size) ] ]! !

!WAStringEmailBody class methodsFor: 'private' stamp: 'lr 7/25/2011 19:50'!
splitString: aString intoChunksNoLongerThan: anInteger
	^ Array streamContents: [ :stream |
		self
			splitString: aString
			intoChunksNoLongerThan: anInteger
			into: stream ]! !

!WAStringEmailBody class methodsFor: 'private' stamp: 'pmm 11/4/2008 11:14'!
splitString: aString intoChunksNoLongerThan: anInteger into: aStream
	| space lastSpaceIndex toScan |
	space := Character space.
	toScan := aString size min: anInteger + 1.
	lastSpaceIndex := 0.
	1 to: toScan do: [ :index |
		(aString at: index) = space ifTrue: [
			lastSpaceIndex := index ] ].
	
	lastSpaceIndex = 0
		ifTrue: [
			lastSpaceIndex := aString size min: anInteger.
			aStream nextPut: (aString copyFrom: 1 to: lastSpaceIndex) ]
		ifFalse: [
			aStream nextPut: (aString copyFrom: 1 to: lastSpaceIndex - 1) ].
		
	lastSpaceIndex < aString size ifTrue: [
		self
			splitString: (aString copyFrom: lastSpaceIndex + 1 to: aString size)
			intoChunksNoLongerThan: anInteger
			into: aStream ]! !

!WAStringEmailBody class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 11/6/2013 15:19'!
string: aString lineLength: anInteger
	| string |
	string := String streamContents: [ :stream |
		| lines |
		lines := self splitIntoLines: (self convertCrLfToCrIn: aString).
		lines do: [ :each |
			each size <= anInteger
				ifTrue: [ stream nextPutAll: each ]
				ifFalse: [
					(self splitString: each intoChunksNoLongerThan: anInteger)
						do: [ :chunk | stream nextPutAll: chunk ]
						separatedBy: [ stream nextPut: Character cr ] ] ]
			separatedBy: [ stream nextPut: Character cr ] ].
	^ self new
		contentString: string;
		yourself! !

!WAStringEmailBody methodsFor: 'accessing' stamp: 'PaulDeBruicker 11/7/2013 10:41'!
contentType
	^ WAMimeType textPlain! !

!WAStringEmailBody methodsFor: 'accessing' stamp: 'PaulDeBruicker 10/25/2013 11:10'!
isPlainText
	^ true! !

!WAStringEmailBody methodsFor: 'accessing' stamp: 'PaulDeBruicker 10/25/2013 11:15'!
sortOrder
	^ 1! !

WAObject subclass: #WAEmailMessage
	instanceVariableNames: 'to from cc bcc subject headers body replyTo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Email'!

!WAEmailMessage class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 19:48'!
from: aFromEmailAddress to: aToEmailAddress subject: aString
	^ self new
		from: aFromEmailAddress;
		addTo: aToEmailAddress;
		subject: aString;
		yourself! !

!WAEmailMessage class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 19:48'!
from: aFromEmailAddress toAll: aCollectionOfEmailAddress subject: aString
	^ self new
		from: aFromEmailAddress;
		addAllTo: aCollectionOfEmailAddress;
		subject: aString;
		yourself! !

!WAEmailMessage methodsFor: 'adding' stamp: 'pmm 8/31/2008 13:44'!
addAllTo: aCollectionOfEmailAddress
	aCollectionOfEmailAddress do: [ :each |
		self addTo: each ]! !

!WAEmailMessage methodsFor: 'adding' stamp: 'lr 7/25/2011 20:01'!
addBcc: anEmailAddress
	^ self bcc add: anEmailAddress! !

!WAEmailMessage methodsFor: 'adding' stamp: 'lr 7/25/2011 20:02'!
addCc: anEmailAddress
	^ self cc add: anEmailAddress! !

!WAEmailMessage methodsFor: 'adding' stamp: 'lr 7/25/2011 20:02'!
addTo: anEmailAddress
	^ self to add: anEmailAddress! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
bcc
	^ bcc! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
body
	^ body! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
body: anObject
	body := anObject! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
cc
	^ cc! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
from
	^ from! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
from: anObject
	from := anObject! !

!WAEmailMessage methodsFor: 'adding' stamp: 'lr 7/25/2011 20:00'!
headerAt: aKeyString put: aValueString
	^ self headers at: aKeyString put: aValueString! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
headers
	^ headers! !

!WAEmailMessage methodsFor: 'initialization' stamp: 'jf 9/30/2009 00:32'!
initialize
	super initialize.
	to := OrderedCollection new.
	cc := OrderedCollection new.
	bcc := OrderedCollection new.
	headers := Dictionary new.
	self 
		headerAt: 'Date'
		put: (GRPrinter rfc822 print: DateAndTime now)! !

!WAEmailMessage methodsFor: 'testing' stamp: 'PaulDeBruicker 10/25/2013 11:57'!
isMultipart
	^ false! !

!WAEmailMessage methodsFor: 'private' stamp: 'PaulDeBruicker 11/7/2013 11:01'!
plainMessage
	^ String
		streamContents: [ :stream | 
			self renderAddress: self from withHeader: 'From: ' on: stream.
			self to do: [ :each | self renderAddress: each withHeader: 'To: ' on: stream ].
			self cc do: [ :each | self renderAddress: each withHeader: 'Cc: ' on: stream ].
			self bcc do: [ :each | self renderAddress: each withHeader: 'Bcc: ' on: stream ].
			stream
				nextPutAll: 'Subject: ';
				nextPutAll: self subject;
				nextPut: Character cr.
			self replyTo isNil
				ifFalse: [ self renderAddress: self replyTo withHeader: 'Reply-To: ' on: stream ].
			self headers
				keysAndValuesDo: [ :key :value | 
					stream
						nextPutAll: key greaseString;
						nextPut: $:;
						nextPut: Character space;
						nextPutAll: value greaseString;
						nextPut: Character cr ].
			stream nextPut: Character cr.	"let body start"
			self writeBodyOn: stream ]! !

!WAEmailMessage methodsFor: 'private' stamp: 'dkh 11/23/2009 15:55'!
recipients
	^ self to , self cc , self bcc collect: [ :each | each greaseString ]! !

!WAEmailMessage methodsFor: 'private' stamp: 'pmm 10/13/2010 21:27'!
recipientsAddresses
	^ Array streamContents: [ :stream |
		self to do: [ :each |
			stream nextPut: each address ].
		self cc do: [ :each |
			stream nextPut: each address ].
		self bcc do: [ :each |
			stream nextPut: each address ] ]! !

!WAEmailMessage methodsFor: 'private' stamp: 'jf 9/30/2009 01:10'!
renderAddress: anEmailAddress withHeader: aString on: aStream 
	aStream
		nextPutAll: aString;
		nextPutAll: anEmailAddress greaseString;
		nextPut: Character cr! !

!WAEmailMessage methodsFor: 'adding' stamp: 'PaulDeBruicker 10/25/2013 09:39'!
replyTo
	^ replyTo! !

!WAEmailMessage methodsFor: 'adding' stamp: 'PaulDeBruicker 10/25/2013 09:38'!
replyTo: anEmailAddress
	replyTo := anEmailAddress! !

!WAEmailMessage methodsFor: 'actions' stamp: 'dkh 11/23/2009 15:03'!
send
	GRPlatform current seasideDeliverEmailMessage: self! !

!WAEmailMessage methodsFor: 'convenience' stamp: 'PaulDeBruicker 10/25/2013 11:40'!
setStringBody: aString
	self setStringBody: aString wrap: false! !

!WAEmailMessage methodsFor: 'convenience' stamp: 'PaulDeBruicker 11/6/2013 15:19'!
setStringBody: aString wrap: aBoolean
	self body: (aBoolean
		ifTrue: [ WAStringEmailBody string: aString lineLength: 80 ]
		ifFalse: [ WAStringEmailBody contentString: aString ])! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
subject
	^ subject! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
subject: anObject
	subject := anObject! !

!WAEmailMessage methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:12'!
to
	^ to! !

!WAEmailMessage methodsFor: 'private' stamp: 'PaulDeBruicker 10/25/2013 11:20'!
writeBodyOn: stream
	self body isNil
		ifFalse: [ stream nextPutAll: self body greaseString ]! !

WAEmailMessage subclass: #WAMultiPartEmailMessage
	instanceVariableNames: 'parts boundary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Email'!

!WAMultiPartEmailMessage class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/25/2013 12:54'!
newBoundary
	^ String
		streamContents: [ :s | 
			s nextPutAll: 'SeasideEmail'.
			s nextPutAll: (10000 to: 999999) atRandom greaseString ]! !

!WAMultiPartEmailMessage methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/25/2013 11:08'!
addPart: aWAEmailBody
	self parts add: aWAEmailBody! !

!WAMultiPartEmailMessage methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/25/2013 11:22'!
boundary
	^ boundary! !

!WAMultiPartEmailMessage methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/6/2013 15:12'!
initialize
	| mimeParameters |
	super initialize.
	boundary := self class newBoundary.
	mimeParameters := Dictionary new.
	mimeParameters at: 'boundary' put: boundary.
	self headerAt: 'Content-Type' put: (WAMimeType main: 'multipart' sub: 'alternative' parameters: mimeParameters)! !

!WAMultiPartEmailMessage methodsFor: 'testing' stamp: 'PaulDeBruicker 10/25/2013 12:00'!
isMultipart
	^ true! !

!WAMultiPartEmailMessage methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/25/2013 11:08'!
parts
	^ parts ifNil: [ parts := Set new ]! !

!WAMultiPartEmailMessage methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/25/2013 11:18'!
setHtmlBody: aBlock
	"block should be in the form of a [:h | h render: 'hello world']"

	self addPart: (WAHtmlEmailBody renderingBlock: aBlock)! !

!WAMultiPartEmailMessage methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/6/2013 15:19'!
setStringBody: aString wrap: aBoolean
	self
		addPart:
			(aBoolean
				ifTrue: [ WAStringEmailBody string: aString lineLength: 80 ]
				ifFalse: [ WAStringEmailBody contentString: aString ])! !

!WAMultiPartEmailMessage methodsFor: 'writing' stamp: 'PaulDeBruicker 10/25/2013 11:43'!
writeBodyOn: stream
	self parts asArray sort
		do: [ :eachPart | 
			self writeMiddleBoundaryOn: stream.
			eachPart writeOn: stream ].
	self writeEndBoundaryOn: stream! !

!WAMultiPartEmailMessage methodsFor: 'writing' stamp: 'PaulDeBruicker 10/25/2013 11:25'!
writeEndBoundaryOn: stream
	stream
		nextPut: Character cr;
		nextPutAll: '--';
		nextPutAll: self boundary;
		nextPutAll: '--';
		nextPut: Character cr! !

!WAMultiPartEmailMessage methodsFor: 'writing' stamp: 'PaulDeBruicker 10/25/2013 11:24'!
writeMiddleBoundaryOn: stream
	stream
		nextPut: Character cr;
		nextPutAll: '--';
		nextPutAll: self boundary;
		nextPut: Character cr! !

!GRPlatform methodsFor: '*seaside-email' stamp: 'dkh 11/25/2009 11:48'!
seasideDeliverEmailMessage: aWAEmailMessage

	self subclassResponsibility! !

!GRPlatform methodsFor: '*seaside-email' stamp: 'pmm 6/19/2011 16:40'!
seasideHandlerPreferenceAt: aKey ifAbsent: aBlock
		
	^ [ WACurrentRequestContext value application preferenceAt: aKey ] "in a Seaside context"
		on: WARequestContextNotFound, WAAttributeNotFound 
		do: [ :ex | aBlock value ] "not in a Seaside context, treat as absent"! !

!GRPlatform methodsFor: '*seaside-email' stamp: 'topa 10/13/2010 12:51'!
seasideSmtpPassword

	"^ self seasideApplicationPreferenceAt: #smtpPassword ifAbsent: [?]"
	self subclassResponsibility! !

!GRPlatform methodsFor: '*seaside-email' stamp: 'topa 10/13/2010 12:51'!
seasideSmtpPort

	"^ self seasideApplicationPreferenceAt: #smtpPort ifAbsent: [?]"
	self subclassResponsibility! !

!GRPlatform methodsFor: '*seaside-email' stamp: 'topa 10/13/2010 12:51'!
seasideSmtpServer
	
	"^ self seasideApplicationPreferenceAt: #smtpServer ifAbsent: [?]"
	self subclassResponsibility! !

!GRPlatform methodsFor: '*seaside-email' stamp: 'topa 10/13/2010 12:51'!
seasideSmtpUsername

	"^ self seasideApplicationPreferenceAt: #smtpUsername ifAbsent: [?]"
	self subclassResponsibility! !

!GRPackage class methodsFor: '*seaside-email' stamp: 'lr 2/17/2010 15:19'!
seasideEmail
	^ self new
		name: 'Seaside-Email';
		description: 'Contains convenience classes for sending of emails and preventing header injections.';
		addDependency: 'Seaside-Core';
		url: #seasideUrl;
		yourself! !

WASystemConfiguration subclass: #WAEmailConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Email-Configuration'!

!WAEmailConfiguration methodsFor: 'description' stamp: 'PaulDeBruicker 11/7/2013 11:01'!
describeOn: config
	(config string: #smtpServer)
		group: #email;
		label: 'SMTP Server';
		comment: 'The hostname of the SMTP Server to use for sending Emails'.
	(config integer: #smtpPort)
		beAdvanced;
		group: #email;
		label: 'SMTP Port';
		comment: 'The port of the SMTP Server to use for sending Emails.';
		default: 25.
	(config string: #smtpUsername)
		beAdvanced;
		group: #email;
		label: 'SMTP Server user name';
		comment: 'The user name used to log into the SMTP Server to use for sending Emails'.
	(config string: #smtpPassword)
		beAdvanced;
		group: #email;
		label: 'SMTP Server password';
		comment: 'The password used to log into the SMTP Server to use for sending Emails'! !
